
package xelfi.browser.document;

import xelfi.browser.view.BrowserPanel;
import java.util.*;
import java.io.*;
import java.awt.*;

public class BrUser extends BrComponent
{
    boolean                 multiprojectMode = true;
    private String          path;
    public boolean          changed = false;
    private boolean         opened = false;
    private Vector          member = new Vector(10,3);

    public BrUser(String pName,String pPath)
    {
        path = pPath;
        name = pName;
    }
    public boolean addComponent(BrComponent prj)
    {
        int i,k = member.size();
        //projectNames.size();
        for(i=0;i<k;i++)
            if( prj.name.equals(((BrProject)member.elementAt(i)).name) )
            //projectNames.elementAt(i)) )
                break;
        if( i == k )
        {
            //projectNames.addElement(prj.name);
            //projectPaths.addElement(prj.path);
            member.addElement(prj);
            changed = true;
            return true;
        }else
            return false;
    }
    public void delProject(BrProject prj)
    {
        //projectNames.removeElement(prj.name);
        //projectPaths.removeElement(prj.path);
        member.removeElement(prj);
        changed = true;
    }
    public BrProject openProject()
    {
        int openedProject;
        if( !opened ) Open();
        if( multiprojectMode )
        {
            //dialog na otevirani projektu...
            openedProject = 0;
        }else
            openedProject = 0;
        return ComponentManager.openProject(
            (BrProject)member.elementAt(openedProject));
    }
    private void Open()
    {
        opened = true;
        File f = new File(path);
        if( path.equals("") )
            f = new File(name + ".xel");
        else
            f = new File(f,name + ".xel");
        //System.out.println("Load file :" + f);
        DataInputStream is;
        try{
            is = new DataInputStream
                (new FileInputStream(f));

            int i,k;
            String str1,str2;
            //projectNames.removeAllElements();
            //projectPaths.removeAllElements();

            k = (new Integer(is.readLine())).intValue();
            //System.out.println("k file :" +k+"  " + f);
            for(i=0;i<k;i++)
            {
                str1 = is.readLine();
                str2 = is.readLine();
                addComponent(new BrProject(this,str1,str2));
                //System.out.println("str file :" + str);
            }
        }catch(FileNotFoundException e)
        {
            //System.out.println("I cann't find file :" + f);
            createDefaultProject();
        }catch(IOException e)
        {
            //System.out.println("Error in file :" + f);
            createDefaultProject();
        }catch(NumberFormatException e)
        {
            //System.out.println("Error in file :" + f);
            createDefaultProject();
        }
        changed = false;
        // !!! markProjectObjects
        return;
    }
    void createDefaultProject()
    {
        //System.out.println("<< I create default project. >>");
        multiprojectMode = false;
        BrProject p = new BrProject(this,"DEFAULT_" + name,path);
        addComponent(p);
        for(Enumeration e = XFile.getAllPaths();
            e.hasMoreElements();)
            p.addPath((String)e.nextElement(),true);
        // !!!  if BrowserSettings.addDefaultClassPath
        changed = false;
        return;
    }
    void save()
    {
        //System.out.println("sSS USER");
        //save1();
        int i,k = member.size();
        for(i=0;i<k;i++)
            ((BrProject)member.elementAt(i)).save();
        //System.out.println("OK USER");
    }
    void save1()
    {
        if( !changed ) return;
        File f = new File(path);
        f = new File(f,name + ".xel");
        //System.out.println("Save file :" + f);
        DataOutputStream is;
        try{
            is = new DataOutputStream
                (new FileOutputStream(f));
        }catch(IOException e)
        {
            System.out.println("I cann't open file :" + f);
            return;
        }
        int i,k = member.size();
            //projectNames.size();
        try{
            is.writeBytes((new Integer(k)).toString());
            is.writeBytes("\n");
            for(i=0;i<k;i++)
            {
                is.writeBytes((String)((BrProject)member.elementAt(i)).name);
                    //(String)projectNames.elementAt(i));
                is.writeBytes("\n");
                is.writeBytes((String)((BrProject)member.elementAt(i)).path);
                    //(String)projectPaths.elementAt(i));
                is.writeBytes("\n");
            }
        }catch(IOException e)
        {
            System.out.println("Error in file :" + f);
            return;
        }
    }
    public int getComponentsNumber(BrSettings bs)
    {
        if( !opened ) Open();
        int i = 0;
        if( bs.MultipleSelectioned ) i = 1;
        return member.size() + i;
    }
    public int getComponents(BrSettings bs,BrComponent[] c,int from)
    {
        if( !opened ) Open();

        if( bs.MultipleSelectioned )
            c[from++] = new BrComponent(name);

        int l = member.size();
        for(int i=0;i<l;i++)
            c[i + from] = (BrComponent)member.elementAt(i);
        return l + from;
    }
    public void openView(Frame f)
    {
        //Musim dodelat
    }
    public boolean selectable()
    {
        return true;
    }

}


