/**
* Xelfi
*/

package xelfi.design.forms;

/**
* This class provides set of default layouts.
* @version 		1.02, 18 Feb 1997
* @finished
* @author 		Ian Formanek
*/

public class XFDefaultLayouts {
	/** 
	* This method returns array of names of default layouts.
	* These names can be used to dynamically create layout design class for this layout.
	*/
	public static String[] get() {
		String list[] = new String[5];
		list[0] = "xelfi.design.forms.layouts.XAbsoluteLayout";
		list[1] = "xelfi.design.forms.layouts.XFlowLayout";
		list[2] = "xelfi.design.forms.layouts.XBorderLayout";
		list[3] = "xelfi.design.forms.layouts.XCardLayout";
		list[4] = "xelfi.design.forms.layouts.XGridLayout";
		return list;
	}
}
